unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,madExceptVcl,madExcept,madCrypt,Winapi.ShellAPI;

type
  TmnForm = class(TForm)
    scrMemo: TMemo;
    dstMemo: TMemo;
    PathEdit: TEdit;
    DoItBtn: TButton;
    PasswordEdit: TEdit;
    MEHandler: TMadExceptionHandler;
    howtoMemo: TMemo;
    SimpleBtn: TButton;
    procedure DoItBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SimpleBtnClick(Sender: TObject);
  private
    procedure AcceptFiles(var Message:TMessage); message WM_DROPFILES;
    procedure MESendReport(action:TExceptAction; const exceptIntf:IMEException; var handled:boolean);
    procedure SetMESettings;
  public
    { Public declarations }
  end;

var
  mnForm: TmnForm;

implementation

{$R *.dfm}

uses System.IOUtils;

procedure TmnForm.AcceptFiles(var Message: TMessage);
const
 cnMaxFileNameLen = 255;
var
 nCount:integer;
 acFileName:array [0..cnMaxFileNameLen] of char;
 fileExtSrc,fileExt,tmpStr,base64Str,fName:ANSIString;
begin
 nCount:=DragQueryFile(Message.WParam,$FFFFFFFF,acFileName,cnMaxFileNameLen);
 try
  if (nCount = 1) then
   begin
    fileExtSrc:=LowerCase(ExtractFileExt(PathEdit.Text));

    DragQueryFile(Message.WParam, 0, acFileName, cnMaxFileNameLen);
    fName:=string(acFileName);
    fileExt:=LowerCase(ExtractFileExt(fName));
    if (fileExtSrc <> fileExt) then
     Exit;

    base64Str:=TFile.ReadAllText(fName);
    base64Str:=TrimRight(base64Str);    //the assistant adds two  cr/lf when the file is saved

    tmpStr:=Decode(base64Str);
    madCrypt.Decrypt(tmpStr,PasswordEdit.Text);          //blowfish

    dstMemo.Lines.Clear;
    dstMemo.Lines.Add(tmpStr);

    if (scrMemo.Lines.Text <> dstMemo.Lines.Text) then
     begin
      beep;
      ShowMessage('Text does not match.');
     end;

  end;
 finally
  DragFinish(Message.WParam);      //let Windows know done
 end;
end;

procedure TmnForm.DoItBtnClick(Sender: TObject);
var
 test:TList;
begin
 test:=nil;
 if (test.count <> 0) then
  ;
end;

procedure TmnForm.SimpleBtnClick(Sender: TObject);
var
 srcString,base64Str,dstStr:ANSIString;
// srcString,base64Str,dstStr:string;
begin

 scrMemo.Lines.Add('Test of encrypt, base64 --- base64, decrypt.');   //A
 srcString:=scrMemo.Lines.Text;                 //get the text
 scrMemo.Lines.Add('');

//encrypt
 madCrypt.Encrypt(srcString,PasswordEdit.Text);
 scrMemo.Lines.Add(srcString);                  //show the result       B
 scrMemo.Lines.Add('');

//convert encrypted string to base 64
 base64Str:=Encode(srcString);                  //base 64
 scrMemo.Lines.Add(base64Str);                  //show the result       C
 scrMemo.Lines.Add('');


//is base 64 just show it is the same
 dstMemo.Lines.Clear;
 dstMemo.Lines.Add(base64Str);                  //show the input        C
 dstMemo.Lines.Add('');

//decode base64 to encrypted string
 dstStr:=Decode(base64Str);
 dstMemo.Lines.Add(dstStr);                     //decode, should be the same as  B
 dstMemo.Lines.Add('');

//decript the string to the source
 madCrypt.Decrypt(dstStr,PasswordEdit.Text);
 dstMemo.Lines.Add(dstStr);                     //should be the same as  A
end;

procedure TmnForm.FormCreate(Sender: TObject);
begin
 DragAcceptFiles(self.Handle,True);
 SetMESettings;
end;

procedure TmnForm.FormDestroy(Sender: TObject);
begin
 DragAcceptFiles(self.Handle,false);
end;

procedure TmnForm.MESendReport(action: TExceptAction; const exceptIntf: IMEException; var handled: boolean);
var
 orgBugReport,base64Str,encryptedStr:ANSIString;
begin
 if (not (action in [eaSaveBugReport2,eaSendBugReport2])) then
  Exit;

 SetMESettings;                          //might have changed file path

 orgBugReport:=AnsiString(exceptIntf.BugReport);

 scrMemo.Lines.Clear;
 scrMemo.Lines.Add(orgBugReport);        //so we can see it for comparsion

//encrypt
 encryptedStr:=orgBugReport;
 madCrypt.Encrypt(encryptedStr,PasswordEdit.Text);

//convert encrypted string to base64, this could be skipped, added as example
 base64Str:=Encode(encryptedStr);        //base64

 exceptIntf.BugReport:=base64Str;        //so the base64 is saved to the file

 if FileExists(PathEdit.Text) then
  DeleteFile(PathEdit.Text);
end;

procedure TmnForm.SetMESettings;
var
 madSettings:IMEModuleSettings;
begin
 RegisterExceptActionHandler(MESendReport,stTrySyncCallAlways);
 madSettings:=MESettings(GetModuleHandle(PWideChar(ExtractFileName(Application.ExeName))));
 madSettings.ScreenShotDepth:=0;
 madSettings.BugReportFile:=PathEdit.Text;
end;

end.
